import { IWorkspaceAutomationService, IGetAutomationOptions, IGetAutomationsOptions, IAutomationsQuery, AutomationType, IAutomationsQueryResult } from "@gooddata/sdk-backend-spi";
import { IAutomationMetadataObjectDefinition, IAutomationMetadataObject } from "@gooddata/sdk-model";
export declare abstract class DecoratedAutomationsQuery implements IAutomationsQuery {
    protected readonly decorated: IAutomationsQuery;
    protected constructor(decorated: IAutomationsQuery);
    withSize(size: number): IAutomationsQuery;
    withPage(page: number): IAutomationsQuery;
    withFilter(filter: {
        title?: string;
    }): IAutomationsQuery;
    withSorting(sort: string[]): IAutomationsQuery;
    withType(type: AutomationType): IAutomationsQuery;
    withAuthor(author: string): IAutomationsQuery;
    withRecipient(recipient: string): IAutomationsQuery;
    withUser(user: string): IAutomationsQuery;
    withDashboard(dashboard: string): IAutomationsQuery;
    query(): Promise<IAutomationsQueryResult>;
    queryAll(): Promise<IAutomationMetadataObject[]>;
}
/**
 * @alpha
 */
export declare abstract class DecoratedWorkspaceAutomationsService implements IWorkspaceAutomationService {
    protected readonly decorated: IWorkspaceAutomationService;
    protected constructor(decorated: IWorkspaceAutomationService);
    createAutomation(automation: IAutomationMetadataObjectDefinition, options?: IGetAutomationOptions): Promise<IAutomationMetadataObject>;
    deleteAutomation(id: string): Promise<void>;
    getAutomation(id: string, options?: IGetAutomationOptions): Promise<IAutomationMetadataObject>;
    getAutomations(options?: IGetAutomationsOptions): Promise<IAutomationMetadataObject[]>;
    getAutomationsQuery(): IAutomationsQuery;
    updateAutomation(automation: IAutomationMetadataObject, options?: IGetAutomationOptions): Promise<IAutomationMetadataObject>;
    unsubscribeAutomation(id: string): Promise<void>;
}
//# sourceMappingURL=automations.d.ts.map